OpenTTD Source: CrashLogUnix Class Reference

OpenTTD Source 12.2

Public Member Functions | Private Member Functions | Private Attributes
CrashLogUnix Class Reference

Unix implementation for the crash logger. More...

Inheritance diagram for CrashLogUnix:

## Public Member Functions
| CrashLogUnix (int signum)
| A crash log is always generated by signal. More...
Public Member Functions inherited from CrashLog
virtual | ~CrashLog ()
| Stub destructor to silence some compilers.
char * | FillCrashLog (char *buffer, const char *last) const
| Fill the crash log buffer with all data of a crash log. More...
bool | WriteCrashLog (const char *buffer, char *filename, const char *filename_last) const
| Write the crash log to a file. More...
virtual int | WriteCrashDump (char *filename, const char *filename_last) const
| Write the (crash) dump to a file. More...
bool | WriteSavegame (char *filename, const char *filename_last) const
| Write the (crash) savegame to a file. More...
bool | WriteScreenshot (char *filename, const char *filename_last) const
| Write the (crash) screenshot to a file. More...
bool | MakeCrashLog () const
| Makes the crash log, writes it to a file and then subsequently tries to make a crash dump and crash savegame. More...

## Private Member Functions
char * | LogOSVersion (char *buffer, const char *last) const override
| Writes OS' version to the buffer. More...
char * | LogError (char *buffer, const char *last, const char *message) const override
| Writes actually encountered error to the buffer. More...
char * | LogStacktrace (char *buffer, const char *last) const override
| Writes the stack trace to the buffer, if there is information about it available. More...

## Private Attributes
int | signum
| Signal that has been thrown.

## Additional Inherited Members
Static Public Member Functions inherited from CrashLog
static void | InitialiseCrashLog ()
| Initialiser for crash logs; do the appropriate things so crashes are handled by our crash handler instead of returning straight to the OS. More...
static void | InitThread ()
| Prepare crash log handler for a newly started thread. More...
static void | SetErrorMessage (const char *message)
| Sets a message for the error message handler. More...
static void | AfterCrashLogCleanup ()
| Try to close the sound/video stuff so it doesn't keep lingering around incorrect video states or so, e.g. More...
Protected Member Functions inherited from CrashLog
virtual char * | LogCompiler (char *buffer, const char *last) const
| Writes compiler (and its version, if available) to the buffer. More...
virtual char * | LogRegisters (char *buffer, const char *last) const
| Writes information about the data in the registers, if there is information about it available. More...
virtual char * | LogModules (char *buffer, const char *last) const
| Writes the dynamically linked libraries/modules to the buffer, if there is information about it available. More...
char * | LogOpenTTDVersion (char *buffer, const char *last) const
| Writes OpenTTD's version to the buffer. More...
char * | LogConfiguration (char *buffer, const char *last) const
| Writes the (important) configuration settings to the buffer. More...
char * | LogLibraries (char *buffer, const char *last) const
| Writes information (versions) of the used libraries. More...
char * | LogGamelog (char *buffer, const char *last) const
| Writes the gamelog data to the buffer. More...
char * | LogRecentNews (char *buffer, const char *list) const
| Writes up to 32 recent news messages to the buffer, with the most recent first. More...
int | CreateFileName (char *filename, const char *filename_last, const char *ext, bool with_dir=true) const
| Create a timestamped filename. More...

## Detailed Description

Unix implementation for the crash logger.

Definition at line 37 of file crashlog_unix.cpp.

## Constructor & Destructor Documentation

## ◆ CrashLogUnix()

CrashLogUnix::CrashLogUnix | ( | int | signum | ) |
| inline

A crash log is always generated by signal.

Parameters

  signum | the signal that was caused by the crash.

Definition at line 137 of file crashlog_unix.cpp.

## Member Function Documentation

## ◆ LogError()

char* CrashLogUnix::LogError | ( | char * | buffer,
|  | const char * | last,
|  | const char * | message
| ) |  | const
| inlineoverrideprivatevirtual

Writes actually encountered error to the buffer.

Parameters

  buffer | The begin where to write at.
  last | The last position in the buffer to write to.
  message | Message passed to use for possible errors. Can be nullptr.

Returns
  the position of the `'\0'` character after the buffer.

Implements CrashLog.

Definition at line 61 of file crashlog_unix.cpp.

References CrashLog::message, and seprintf().

## ◆ LogOSVersion()

char* CrashLogUnix::LogOSVersion | ( | char * | buffer,
|  | const char * | last
| ) |  | const
| inlineoverrideprivatevirtual

Writes OS' version to the buffer.

Parameters

  buffer | The begin where to write at.
  last | The last position in the buffer to write to.

Returns
  the position of the `'\0'` character after the buffer.

Implements CrashLog.

Definition at line 41 of file crashlog_unix.cpp.

References seprintf().

## ◆ LogStacktrace()

char* CrashLogUnix::LogStacktrace | ( | char * | buffer,
|  | const char * | last
| ) |  | const
| inlineoverrideprivatevirtual

Writes the stack trace to the buffer, if there is information about it available.

Parameters

  buffer | The begin where to write at.
  last | The last position in the buffer to write to.

Returns
  the position of the `'\0'` character after the buffer.

Implements CrashLog.

Definition at line 106 of file crashlog_unix.cpp.

References free(), lengthof, and seprintf().

The documentation for this class was generated from the following file:

- src/os/unix/crashlog_unix.cpp